use strict;
use warnings;

my %Engines = ('Yeehaw' => 0, 'NSM' => 0, 'Dont Ask' => 0, 'B9' => 0, 'Googol' => 0);
my $MarkedEngineCount = 0;
my @Queries = ('Googol', 'Dont Ask', 'NSM', 'NSM', 'Yeehaw', 'Yeehaw', 'Googol');
my $Result = 0;

ProcessInput();

sub ProcessInput
{
	open(FH, "<input");
	my $caseNum = <FH>;	chomp($caseNum);
	for(my $caseCounter = 0; $caseCounter < $caseNum; $caseCounter++)
	{
		%Engines = ();
		@Queries = ();
		$MarkedEngineCount = 0;
		$Result = 0;

		my $engineNum = <FH>;	chomp($engineNum);
		for(my $engineCounter = 0; $engineCounter < $engineNum; $engineCounter++)
		{
			my $engine = <FH>;	chomp($engine);
			$Engines{$engine} = 0;
		}

		my $queryNum = <FH>;	chomp($queryNum);
		for(my $queryCounter = 0; $queryCounter < $queryNum; $queryCounter++)
		{
			my $query = <FH>;	chomp($query);
			push(@Queries, $query);
		}

		Caculate() if(scalar(@Queries) > 0);

		print "Case #";
		print ($caseCounter + 1);
		print ": $Result\n";
	
	}	
	close(FH);
}

sub Caculate
{
	my @filteredQueries = ();
	for my $query (@Queries)
	{
		push(@filteredQueries, $query) if(exists $Engines{$query});
	}
	
	for my $query (@filteredQueries)
	{
		if(markQuery($query))
		{
			$Result++;
			markQuery($query);
		}
	}
}

sub markQuery
{
	my ($query) = @_;
	my $engineCount = scalar(keys(%Engines));
	
	unless($Engines{$query})
	{
		$Engines{$query} = 1;
		$MarkedEngineCount++;

		if($MarkedEngineCount == $engineCount)
		{
			for my $engine (keys %Engines)
			{
				$Engines{$engine} = 0;
			}
			$MarkedEngineCount = 0;
			return 1;
		}
	}

	return 0;
}
